  type 'a cell = {info: 'a; mutable next: 'a cell}

  let make_cl v = let rec c = {info=v;next=c} in c
  
  let hd {info=v;next=l} = l.info
  
  let insert_tl v cl = let el = {info=v;next=cl.next}
                       in cl.next<-el; el
  
  let remove_hd cl = cl.next<- cl.next.next; cl
  
  type 'a circ_list = Nil | List of 'a cell
  
  let insert_tail v = function Nil -> List (make_cl v)
                      | List cl    -> List (insert_tl v cl)
  
  exception Remove_Empty_cl
  
  let remove_head   = function Nil -> raise Remove_Empty_cl
                      | List cl    -> let v =hd cl
                                      in let l= if cl.next==cl.next.next then Nil
                                                else List (remove_hd cl)
                                         in (v,l)
  exception FileVide
  type 'a file = 'a circ_list
  let mkempty () = Nil
  let enqueue v l = insert_tail v l
  let dequeue l = try remove_head l with Remove_Empty_cl -> raise FileVide
  let isempty = function Nil -> true | _ -> false
