  type 'a file = 'a list * 'a list
  exception FileVide
  let mkempty () = [],[]
  let enqueue v (l1,l2) = (l1,v::l2)
  let dequeue = function (a::r,l)   -> a,(r,l)
                |        ([], [])   -> raise FileVide
                |        ([], l)    -> let (a::l') = List.rev l in (a,(l',[]))
                                       (* ici le compilateur ne voit pas que l est non vide *)
  let isempty = function ([],[]) -> true
                |           _    -> false
